#version 120

varying vec4 color;
varying vec3 normal;
varying vec4 vertex_3d_original;
varying vec4 vertex_3d_modelview;

vec3 light=vec3(2,2,0);

void main (void)
{
    vec3 n=normalize(normal);
    vec3 p=vertex_3d_modelview.xyz;
    vec3 vertex_to_light=normalize(light-p);
    vec3 reflected_light=reflect(-vertex_to_light,n);
    vec3 user_to_vertex=normalize(-p);

    float diffuse_term=0.7*clamp(dot(n,vertex_to_light),0,1);
    float specular_term=0.2*pow(clamp(dot(reflected_light,user_to_vertex),0,1),128);
    float ambiant_term=0.2;

    vec4 white=vec4(1,1,1,0);

    gl_FragColor = (ambiant_term+diffuse_term)*color+specular_term*white;
}
